> ## Documentation Index
> Fetch the complete documentation index at: https://doc.extole.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Duplicate a component

> Creates a deep copy of the specified component and all its child settings and assets.



## OpenAPI

````yaml /api-reference/management.json post /v1/components/{component_id}{version}/duplicate
openapi: 3.0.1
info:
  description: >-
    Configuration endpoints for the Extole platform: campaigns, components,
    audiences, persons, rewards, reporting, integrations setup, and
    administrative tooling.
  title: Management API
  version: '1.0'
servers:
  - description: Production
    url: https://api.extole.io
security:
  - HEADER: []
  - QUERY: []
  - COOKIE: []
tags:
  - name: Audiences
  - name: Authentication
  - name: Batch Jobs
  - name: Blocks
  - name: Campaigns
  - name: Components
  - name: Components Settings
  - name: Domains
  - name: Email
  - name: Erasure
  - name: Event Streams
  - name: File Validation Monitors
  - name: Optout
  - name: Profiles
  - name: Promotion Links
  - name: Report Schedules
  - name: Report Types
  - name: Reports
  - name: Reward Suppliers
  - name: Security Keys
  - name: Settings
  - name: User Notifications
  - name: User Subscriptions
  - name: Users
  - name: Webhooks
paths:
  /v1/components/{component_id}{version}/duplicate:
    post:
      tags:
        - Components
      summary: Duplicate a component
      description: >-
        Creates a deep copy of the specified component and all its child
        settings and assets.
      operationId: duplicateComponent
      parameters:
        - in: path
          name: component_id
          required: true
          schema:
            type: string
        - in: path
          name: version
          required: true
          schema:
            pattern: (/version/.+)?
            type: string
      requestBody:
        content:
          application/json:
            example:
              anchors:
                - source_element_id: source_element_id
                  target_element_id: target_element_id
              component_display_name: component_display_name
              component_ids:
                - component_id
              component_name: component_name
              component_references:
                - component_id: component_id
                  socket_names:
                    - socket_name
              description: description
              tags:
                - tag
              target_campaign_id: target_campaign_id
              target_component_absolute_name: target_component_absolute_name
              target_setting_name: target_setting_name
              target_socket_name: target_socket_name
              type: type
              types:
                - type
              variables:
                - description: description
                  display_name: display_name
                  name: name
                  priority: '10'
                  source: INHERITED
                  tags:
                    - tag
                  type: ADMIN_ICON
                  values:
                    values_key: {}
            schema:
              $ref: '#/components/schemas/ComponentDuplicateRequest'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ComponentResponse'
          description: Successful response
        '400':
          content:
            application/json:
              examples:
                ambiguous_anchor:
                  $ref: '#/components/examples/ambiguous_anchor'
                audience_build_failed:
                  $ref: '#/components/examples/audience_build_failed'
                authorization_url_invalid:
                  $ref: '#/components/examples/authorization_url_invalid'
                authorization_url_invalid_uri:
                  $ref: '#/components/examples/authorization_url_invalid_uri'
                authorization_url_too_long:
                  $ref: '#/components/examples/authorization_url_too_long'
                binding_error:
                  $ref: '#/components/examples/binding_error'
                build_failed:
                  $ref: '#/components/examples/build_failed'
                campaign_build_failed:
                  $ref: '#/components/examples/campaign_build_failed'
                campaign_component_absolute_name_missing:
                  $ref: >-
                    #/components/examples/campaign_component_absolute_name_missing
                campaign_component_description_out_of_range:
                  $ref: >-
                    #/components/examples/campaign_component_description_out_of_range
                campaign_component_display_name_contains_illegal_character:
                  $ref: >-
                    #/components/examples/campaign_component_display_name_contains_illegal_character
                campaign_component_display_name_out_of_range:
                  $ref: >-
                    #/components/examples/campaign_component_display_name_out_of_range
                campaign_component_id_missing:
                  $ref: '#/components/examples/campaign_component_id_missing'
                campaign_component_name_already_in_use:
                  $ref: '#/components/examples/campaign_component_name_already_in_use'
                campaign_component_name_contains_illegal_character:
                  $ref: >-
                    #/components/examples/campaign_component_name_contains_illegal_character
                campaign_component_name_out_of_range:
                  $ref: '#/components/examples/campaign_component_name_out_of_range'
                campaign_component_not_found:
                  $ref: '#/components/examples/campaign_component_not_found'
                campaign_component_root_rename:
                  $ref: '#/components/examples/campaign_component_root_rename'
                campaign_component_type_validation_failed:
                  $ref: >-
                    #/components/examples/campaign_component_type_validation_failed
                campaign_concurrent_update:
                  $ref: '#/components/examples/campaign_concurrent_update'
                campaign_has_pending_changes:
                  $ref: '#/components/examples/campaign_has_pending_changes'
                campaign_locked:
                  $ref: '#/components/examples/campaign_locked'
                campaign_stale_version:
                  $ref: '#/components/examples/campaign_stale_version'
                campaign_version_malformed:
                  $ref: '#/components/examples/campaign_version_malformed'
                circular_component_reference:
                  $ref: '#/components/examples/circular_component_reference'
                client_key_build_failed:
                  $ref: '#/components/examples/client_key_build_failed'
                client_key_invalid_description:
                  $ref: '#/components/examples/client_key_invalid_description'
                client_key_invalid_name:
                  $ref: '#/components/examples/client_key_invalid_name'
                client_key_missing_name:
                  $ref: '#/components/examples/client_key_missing_name'
                component_collision:
                  $ref: '#/components/examples/component_collision'
                component_element_uniqueness_required:
                  $ref: '#/components/examples/component_element_uniqueness_required'
                component_facets_not_found:
                  $ref: '#/components/examples/component_facets_not_found'
                component_id_not_accessible:
                  $ref: '#/components/examples/component_id_not_accessible'
                component_install_failed:
                  $ref: '#/components/examples/component_install_failed'
                component_not_found:
                  $ref: '#/components/examples/component_not_found'
                component_owner_not_supported:
                  $ref: '#/components/examples/component_owner_not_supported'
                component_state_not_supported:
                  $ref: '#/components/examples/component_state_not_supported'
                component_type_not_found:
                  $ref: '#/components/examples/component_type_not_found'
                controller_build_failed:
                  $ref: '#/components/examples/controller_build_failed'
                controller_state_misconfiguration:
                  $ref: '#/components/examples/controller_state_misconfiguration'
                coupon_count_warn_limit_invalid:
                  $ref: '#/components/examples/coupon_count_warn_limit_invalid'
                coupon_pool_id_missing:
                  $ref: '#/components/examples/coupon_pool_id_missing'
                creative_archive_size_too_big:
                  $ref: '#/components/examples/creative_archive_size_too_big'
                creative_asset_file_path_invalid:
                  $ref: '#/components/examples/creative_asset_file_path_invalid'
                creative_asset_file_path_too_long:
                  $ref: '#/components/examples/creative_asset_file_path_too_long'
                creative_asset_file_size_too_big:
                  $ref: '#/components/examples/creative_asset_file_size_too_big'
                creative_asset_invalid_character_encoding:
                  $ref: >-
                    #/components/examples/creative_asset_invalid_character_encoding
                creative_has_default_locale_disabled:
                  $ref: '#/components/examples/creative_has_default_locale_disabled'
                creative_has_incompatible_api_version:
                  $ref: '#/components/examples/creative_has_incompatible_api_version'
                creative_has_invalid_api_version:
                  $ref: '#/components/examples/creative_has_invalid_api_version'
                creative_has_invalid_locale:
                  $ref: '#/components/examples/creative_has_invalid_locale'
                creative_has_unknown_classification:
                  $ref: '#/components/examples/creative_has_unknown_classification'
                creative_is_missing_attributes:
                  $ref: '#/components/examples/creative_is_missing_attributes'
                creative_is_missing_renderer:
                  $ref: '#/components/examples/creative_is_missing_renderer'
                creative_mismatch_api_version:
                  $ref: '#/components/examples/creative_mismatch_api_version'
                date_invalid:
                  $ref: '#/components/examples/date_invalid'
                default_key_not_allowed:
                  $ref: '#/components/examples/default_key_not_allowed'
                description_too_long:
                  $ref: '#/components/examples/description_too_long'
                display_name_has_illegal_character:
                  $ref: '#/components/examples/display_name_has_illegal_character'
                display_name_too_long:
                  $ref: '#/components/examples/display_name_too_long'
                download_error:
                  $ref: '#/components/examples/download_error'
                event_stream_invalid_name:
                  $ref: '#/components/examples/event_stream_invalid_name'
                event_stream_missing_name:
                  $ref: '#/components/examples/event_stream_missing_name'
                event_stream_validation_failed:
                  $ref: '#/components/examples/event_stream_validation_failed'
                excessive_component_reference:
                  $ref: '#/components/examples/excessive_component_reference'
                expression_invalid_syntax:
                  $ref: '#/components/examples/expression_invalid_syntax'
                external_element_is_referenced_by_active_configuration:
                  $ref: >-
                    #/components/examples/external_element_is_referenced_by_active_configuration
                external_elements_cannot_have_multiple_references:
                  $ref: >-
                    #/components/examples/external_elements_cannot_have_multiple_references
                face_value_out_of_range:
                  $ref: '#/components/examples/face_value_out_of_range'
                illegal_character_in_description:
                  $ref: '#/components/examples/illegal_character_in_description'
                illegal_character_in_name:
                  $ref: '#/components/examples/illegal_character_in_name'
                illegal_value_of_minimum_coupon_lifetime:
                  $ref: >-
                    #/components/examples/illegal_value_of_minimum_coupon_lifetime
                invalid_anchor:
                  $ref: '#/components/examples/invalid_anchor'
                invalid_archive_id:
                  $ref: '#/components/examples/invalid_archive_id'
                invalid_audience_name:
                  $ref: '#/components/examples/invalid_audience_name'
                invalid_campaign_id:
                  $ref: '#/components/examples/invalid_campaign_id'
                invalid_campaign_state:
                  $ref: '#/components/examples/invalid_campaign_state'
                invalid_campaign_version:
                  $ref: '#/components/examples/invalid_campaign_version'
                invalid_cash_back_limits:
                  $ref: '#/components/examples/invalid_cash_back_limits'
                invalid_component_installed_into_socket:
                  $ref: >-
                    #/components/examples/invalid_component_installed_into_socket
                invalid_component_reference:
                  $ref: '#/components/examples/invalid_component_reference'
                invalid_component_reference_socket_name:
                  $ref: >-
                    #/components/examples/invalid_component_reference_socket_name
                invalid_external_component_reference:
                  $ref: '#/components/examples/invalid_external_component_reference'
                invalid_json:
                  $ref: '#/components/examples/invalid_json'
                invalid_limits:
                  $ref: '#/components/examples/invalid_limits'
                invalid_parameter:
                  $ref: '#/components/examples/invalid_parameter'
                invalid_setting_filter:
                  $ref: '#/components/examples/invalid_setting_filter'
                invalid_tag:
                  $ref: '#/components/examples/invalid_tag'
                invalid_translatable_value:
                  $ref: '#/components/examples/invalid_translatable_value'
                invalid_trigger_phase:
                  $ref: '#/components/examples/invalid_trigger_phase'
                javascript_error:
                  $ref: '#/components/examples/javascript_error'
                limit_out_of_range:
                  $ref: '#/components/examples/limit_out_of_range'
                lock_missing_lock_types:
                  $ref: '#/components/examples/lock_missing_lock_types'
                many_default_anchors:
                  $ref: '#/components/examples/many_default_anchors'
                missing_anchor:
                  $ref: '#/components/examples/missing_anchor'
                missing_anchor_source_element_id:
                  $ref: '#/components/examples/missing_anchor_source_element_id'
                missing_anchor_target_element_id:
                  $ref: '#/components/examples/missing_anchor_target_element_id'
                missing_audience_name:
                  $ref: '#/components/examples/missing_audience_name'
                missing_authorization_url:
                  $ref: '#/components/examples/missing_authorization_url'
                missing_request_body:
                  $ref: '#/components/examples/missing_request_body'
                missing_source_component_type:
                  $ref: '#/components/examples/missing_source_component_type'
                missing_target_component_by_absolute_name:
                  $ref: >-
                    #/components/examples/missing_target_component_by_absolute_name
                multiple_components_installed_into_single_socket:
                  $ref: >-
                    #/components/examples/multiple_components_installed_into_single_socket
                name_too_long:
                  $ref: '#/components/examples/name_too_long'
                negative_cash_back_percentage:
                  $ref: '#/components/examples/negative_cash_back_percentage'
                negative_max_cash_back:
                  $ref: '#/components/examples/negative_max_cash_back'
                negative_min_cash_back:
                  $ref: '#/components/examples/negative_min_cash_back'
                no_default_anchor:
                  $ref: '#/components/examples/no_default_anchor'
                non_translatable_variable_can_not_be_updated:
                  $ref: >-
                    #/components/examples/non_translatable_variable_can_not_be_updated
                orphan_external_component_reference:
                  $ref: '#/components/examples/orphan_external_component_reference'
                parent_trigger_group_name_does_not_exist:
                  $ref: >-
                    #/components/examples/parent_trigger_group_name_does_not_exist
                parent_trigger_group_name_is_not_a_group:
                  $ref: >-
                    #/components/examples/parent_trigger_group_name_is_not_a_group
                prehandler_build_failed:
                  $ref: '#/components/examples/prehandler_build_failed'
                prehandler_description_length_out_of_range:
                  $ref: >-
                    #/components/examples/prehandler_description_length_out_of_range
                prehandler_name_contains_illegal_character:
                  $ref: >-
                    #/components/examples/prehandler_name_contains_illegal_character
                prehandler_name_duplicated:
                  $ref: '#/components/examples/prehandler_name_duplicated'
                prehandler_name_length_out_of_range:
                  $ref: '#/components/examples/prehandler_name_length_out_of_range'
                prehandler_name_missing:
                  $ref: '#/components/examples/prehandler_name_missing'
                prehandler_tag_invalid:
                  $ref: '#/components/examples/prehandler_tag_invalid'
                rebuild_campaigns_build_failed:
                  $ref: '#/components/examples/rebuild_campaigns_build_failed'
                redundant_component_reference:
                  $ref: '#/components/examples/redundant_component_reference'
                report_type_not_found:
                  $ref: '#/components/examples/report_type_not_found'
                reward_supplier_build_failed:
                  $ref: '#/components/examples/reward_supplier_build_failed'
                reward_supplier_duplicated_name:
                  $ref: '#/components/examples/reward_supplier_duplicated_name'
                reward_supplier_id_list_invalid_configuration:
                  $ref: >-
                    #/components/examples/reward_supplier_id_list_invalid_configuration
                reward_supplier_validation_failed:
                  $ref: '#/components/examples/reward_supplier_validation_failed'
                reward_supplier_webhook_filter_is_missing:
                  $ref: >-
                    #/components/examples/reward_supplier_webhook_filter_is_missing
                reward_supplier_webhook_filter_not_found:
                  $ref: >-
                    #/components/examples/reward_supplier_webhook_filter_not_found
                self_component_reference:
                  $ref: '#/components/examples/self_component_reference'
                setting_batch_update_missing_request:
                  $ref: '#/components/examples/setting_batch_update_missing_request'
                setting_display_name_length_out_of_range:
                  $ref: >-
                    #/components/examples/setting_display_name_length_out_of_range
                setting_filter_component_facet_mismatch:
                  $ref: >-
                    #/components/examples/setting_filter_component_facet_mismatch
                setting_filter_component_facet_name_missing:
                  $ref: >-
                    #/components/examples/setting_filter_component_facet_name_missing
                setting_filter_component_facet_value_missing:
                  $ref: >-
                    #/components/examples/setting_filter_component_facet_value_missing
                setting_filter_component_type_missing:
                  $ref: '#/components/examples/setting_filter_component_type_missing'
                setting_filter_expression_evaluation_failed:
                  $ref: >-
                    #/components/examples/setting_filter_expression_evaluation_failed
                setting_filter_invalid_component_facet:
                  $ref: '#/components/examples/setting_filter_invalid_component_facet'
                setting_filter_invalid_component_type:
                  $ref: '#/components/examples/setting_filter_invalid_component_type'
                setting_filter_type_mismatch:
                  $ref: '#/components/examples/setting_filter_type_mismatch'
                setting_name_duplicated:
                  $ref: '#/components/examples/setting_name_duplicated'
                setting_name_length_out_of_range:
                  $ref: '#/components/examples/setting_name_length_out_of_range'
                setting_name_missing:
                  $ref: '#/components/examples/setting_name_missing'
                setting_name_reserved:
                  $ref: '#/components/examples/setting_name_reserved'
                setting_not_found:
                  $ref: '#/components/examples/setting_not_found'
                setting_validation_exception:
                  $ref: '#/components/examples/setting_validation_exception'
                settings_build_failed:
                  $ref: '#/components/examples/settings_build_failed'
                socket_missing_required_parameter:
                  $ref: '#/components/examples/socket_missing_required_parameter'
                socket_not_found:
                  $ref: '#/components/examples/socket_not_found'
                tag_length_out_of_range:
                  $ref: '#/components/examples/tag_length_out_of_range'
                trigger_belongs_to_a_cycle:
                  $ref: '#/components/examples/trigger_belongs_to_a_cycle'
                trigger_group_is_not_empty:
                  $ref: '#/components/examples/trigger_group_is_not_empty'
                triggers_with_duplicate_name:
                  $ref: '#/components/examples/triggers_with_duplicate_name'
                unavailable_referenced_variable:
                  $ref: '#/components/examples/unavailable_referenced_variable'
                unknown_source_clients:
                  $ref: '#/components/examples/unknown_source_clients'
                unknown_webhook_type:
                  $ref: '#/components/examples/unknown_webhook_type'
                unlock_missing_lock_types:
                  $ref: '#/components/examples/unlock_missing_lock_types'
                unrecognized_anchors:
                  $ref: '#/components/examples/unrecognized_anchors'
                unsupported_face_value_algorithm_type:
                  $ref: '#/components/examples/unsupported_face_value_algorithm_type'
                upload_error:
                  $ref: '#/components/examples/upload_error'
                variable_batch_update_has_duplicated_variable_name:
                  $ref: >-
                    #/components/examples/variable_batch_update_has_duplicated_variable_name
                variable_batch_update_invalid_type:
                  $ref: '#/components/examples/variable_batch_update_invalid_type'
                variable_batch_update_missing_type:
                  $ref: '#/components/examples/variable_batch_update_missing_type'
                variable_circular_reference:
                  $ref: '#/components/examples/variable_circular_reference'
                variable_description_length_out_of_range:
                  $ref: >-
                    #/components/examples/variable_description_length_out_of_range
                variable_value_invalid_type:
                  $ref: '#/components/examples/variable_value_invalid_type'
                variable_value_key_length_out_of_range:
                  $ref: '#/components/examples/variable_value_key_length_out_of_range'
                variable_value_missing:
                  $ref: '#/components/examples/variable_value_missing'
                webhook_build_failed:
                  $ref: '#/components/examples/webhook_build_failed'
                webhook_client_key_not_found:
                  $ref: '#/components/examples/webhook_client_key_not_found'
                webhook_invalid_default_method:
                  $ref: '#/components/examples/webhook_invalid_default_method'
                webhook_invalid_description:
                  $ref: '#/components/examples/webhook_invalid_description'
                webhook_invalid_name:
                  $ref: '#/components/examples/webhook_invalid_name'
                webhook_invalid_tag:
                  $ref: '#/components/examples/webhook_invalid_tag'
                webhook_local_or_internal_url:
                  $ref: '#/components/examples/webhook_local_or_internal_url'
                webhook_malformed_url:
                  $ref: '#/components/examples/webhook_malformed_url'
                webhook_missing_name:
                  $ref: '#/components/examples/webhook_missing_name'
                webhook_missing_url:
                  $ref: '#/components/examples/webhook_missing_url'
                webhook_name_duplicate:
                  $ref: '#/components/examples/webhook_name_duplicate'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Bad Request
        '401':
          content:
            application/json:
              examples:
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unauthorized
        '402':
          content:
            application/json:
              examples:
                payment_required:
                  $ref: '#/components/examples/payment_required'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Payment Required
        '403':
          content:
            application/json:
              examples:
                access_denied:
                  $ref: '#/components/examples/access_denied'
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
                missing_access_token:
                  $ref: '#/components/examples/missing_access_token'
                reward_supplier_not_found:
                  $ref: '#/components/examples/reward_supplier_not_found'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Forbidden
        '415':
          content:
            application/json:
              examples:
                unsupported_media_type:
                  $ref: '#/components/examples/unsupported_media_type'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unsupported Media Type
        '429':
          content:
            application/json:
              examples:
                too_many_requests:
                  $ref: '#/components/examples/too_many_requests'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Too Many Requests
components:
  schemas:
    ComponentDuplicateRequest:
      properties:
        anchors:
          items:
            $ref: '#/components/schemas/AnchorRequest'
          type: array
        component_display_name:
          $ref: '#/components/schemas/ComponentDisplayNameInComponentDuplicateRequest'
        component_ids:
          items:
            type: string
          type: array
        component_name:
          type: string
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceRequest'
          type: array
        description:
          nullable: true
          type: string
        tags:
          items:
            type: string
          type: array
          uniqueItems: true
        target_campaign_id:
          type: string
        target_component_absolute_name:
          type: string
        target_setting_name:
          type: string
        target_socket_name:
          type: string
        type:
          nullable: true
          type: string
        types:
          items:
            type: string
          type: array
        variables:
          items:
            $ref: '#/components/schemas/CampaignComponentSettingRequest'
          type: array
      type: object
    ComponentResponse:
      description: >-
        Stored component definition. Field `display_name` is unevaluated and
        appears in buildtime-evaluatable form.
      properties:
        assets:
          items:
            $ref: '#/components/schemas/ComponentAssetResponse'
          type: array
        campaign_id:
          type: string
        campaign_state:
          type: string
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        created_date:
          $ref: '#/components/schemas/ZonedDateTime'
        description:
          type: string
        display_name:
          $ref: '#/components/schemas/DisplayNameInComponentResponse'
        facets:
          items:
            $ref: '#/components/schemas/CampaignComponentFacetResponse'
          type: array
        id:
          readOnly: true
          type: string
        install:
          $ref: '#/components/schemas/InstallInComponentResponse'
        installed_into_socket:
          type: string
        name:
          type: string
        origin:
          $ref: '#/components/schemas/ComponentOriginResponse'
        owner:
          enum:
            - CLIENT
            - EXTOLE
            - EXTOLE_BETA
          type: string
        source_client_id:
          type: string
        tags:
          items:
            type: string
          type: array
          uniqueItems: true
        type:
          type: string
        types:
          items:
            type: string
          type: array
        updated_date:
          $ref: '#/components/schemas/ZonedDateTime'
        upload_version:
          type: string
        variables:
          items:
            $ref: '#/components/schemas/CampaignComponentSettingResponse'
          type: array
        version:
          format: int32
          type: integer
      required:
        - assets
        - campaign_id
        - campaign_state
        - component_ids
        - component_references
        - created_date
        - description
        - display_name
        - facets
        - id
        - install
        - installed_into_socket
        - name
        - origin
        - owner
        - source_client_id
        - tags
        - type
        - types
        - updated_date
        - upload_version
        - variables
        - version
      type: object
    RestExceptionResponse:
      description: Represents the API error response
      properties:
        code:
          description: Specific error code for this error type, documented per endpoint
          type: string
        http_status_code:
          description: >-
            HTTP status code that was returned with this error, useful if client
            get response code
          format: int32
          type: integer
        message:
          description: User readable English description of the error
          type: string
        parameters:
          additionalProperties:
            description: >-
              Attributes related to the error, varies be error code, documented
              per endpoint
            type: object
          description: >-
            Attributes related to the error, varies be error code, documented
            per endpoint
          type: object
        unique_id:
          description: >-
            Unique id associated with this error, useful for discussions with
            Extole
          type: string
      required:
        - code
        - http_status_code
        - message
        - parameters
        - unique_id
      type: object
    AnchorRequest:
      properties:
        source_element_id:
          type: string
        target_element_id:
          type: string
      type: object
    ComponentDisplayNameInComponentDuplicateRequest:
      description: Choose between static or dynamic component display name
      oneOf:
        - description: Static component display name
          nullable: true
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{componentDisplayName}}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('componentDisplayName');}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    ComponentReferenceRequest:
      properties:
        component_id:
          type: string
        socket_names:
          items:
            type: string
          type: array
      type: object
    CampaignComponentSettingRequest:
      discriminator:
        mapping:
          ADMIN_ICON:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsAdminIcon'
          AUDIENCE_ID:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsAudienceId'
          AUDIENCE_ID_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentVariableRequestAsAudienceIdList
          BOOLEAN:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsBoolean'
          BROWSER_SIDE_JAVASCRIPT:
            $ref: >-
              #/components/schemas/CampaignComponentVariableRequestAsBrowserSideJavascript
          CLIENT_DOMAIN_ID_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentVariableRequestAsClientDomainIdList
          CLIENT_KEY:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsClientKey'
          CLIENT_KEY_FLOW:
            $ref: '#/components/schemas/CampaignComponentClientKeyFlowVariableRequest'
          COLOR:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsColor'
          COMPONENT_ID:
            $ref: '#/components/schemas/CampaignComponentComponentIdVariableRequest'
          COMPONENT_SETTING_LOOKUP:
            $ref: >-
              #/components/schemas/CampaignComponentComponentSettingLookupVariableRequest
          CSS:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsCss'
          DELAY:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsDelay'
          DELAY_LIST:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsDelayList'
          ENUM:
            $ref: '#/components/schemas/CampaignComponentEnumVariableRequest'
          ENUM_LIST:
            $ref: '#/components/schemas/CampaignComponentEnumListVariableRequest'
          EXTOLE_CLIENT_KEY:
            $ref: >-
              #/components/schemas/CampaignComponentVariableRequestAsExtoleClientKey
          FONT:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsFont'
          GLOB_COMPONENT_PATH:
            $ref: >-
              #/components/schemas/CampaignComponentVariableRequestAsGlobComponentPath
          HTML:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsHtml'
          IMAGE:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsImage'
          INTEGER:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsInteger'
          INTEGER_LIST:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsIntegerList'
          JSON:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsJson'
          MULTI_SOCKET:
            $ref: '#/components/schemas/CampaignComponentSocketRequestAsMultiSocket'
          PARTNER_ENUM:
            $ref: '#/components/schemas/CampaignComponentPartnerEnumVariableRequest'
          PARTNER_ENUM_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentPartnerEnumListVariableRequest
          PERSON_KEY_NAME:
            $ref: >-
              #/components/schemas/CampaignComponentVariableRequestAsPersonKeyName
          REWARD_SUPPLIER_ID:
            $ref: >-
              #/components/schemas/CampaignComponentVariableRequestAsRewardSupplierId
          REWARD_SUPPLIER_ID_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentRewardSupplierIdListVariableRequest
          SOCKET:
            $ref: '#/components/schemas/CampaignComponentSocketRequestAsSocket'
          STRING:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsString'
          STRING_LIST:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsStringList'
          STRING_MAP:
            $ref: '#/components/schemas/CampaignComponentStringMapVariableRequest'
          URL:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsUrl'
          WEBHOOK_ID:
            $ref: '#/components/schemas/CampaignComponentVariableRequestAsWebhookId'
        propertyName: type
      oneOf:
        - title: ADMIN_ICON
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsAdminIcon'
        - title: AUDIENCE_ID
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableRequestAsAudienceId
        - title: AUDIENCE_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableRequestAsAudienceIdList
        - title: BOOLEAN
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsBoolean'
        - title: BROWSER_SIDE_JAVASCRIPT
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableRequestAsBrowserSideJavascript
        - title: CLIENT_DOMAIN_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableRequestAsClientDomainIdList
        - title: CLIENT_KEY
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsClientKey'
        - title: CLIENT_KEY_FLOW
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentClientKeyFlowVariableRequest
        - title: COLOR
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsColor'
        - title: COMPONENT_ID
          allOf:
            - $ref: '#/components/schemas/CampaignComponentComponentIdVariableRequest'
        - title: COMPONENT_SETTING_LOOKUP
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentComponentSettingLookupVariableRequest
        - title: CSS
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsCss'
        - title: DELAY
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsDelay'
        - title: DELAY_LIST
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsDelayList'
        - title: ENUM
          allOf:
            - $ref: '#/components/schemas/CampaignComponentEnumVariableRequest'
        - title: ENUM_LIST
          allOf:
            - $ref: '#/components/schemas/CampaignComponentEnumListVariableRequest'
        - title: EXTOLE_CLIENT_KEY
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableRequestAsExtoleClientKey
        - title: FONT
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsFont'
        - title: GLOB_COMPONENT_PATH
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableRequestAsGlobComponentPath
        - title: HTML
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsHtml'
        - title: IMAGE
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsImage'
        - title: INTEGER
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsInteger'
        - title: INTEGER_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableRequestAsIntegerList
        - title: JSON
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsJson'
        - title: MULTI_SOCKET
          allOf:
            - $ref: '#/components/schemas/CampaignComponentSocketRequestAsMultiSocket'
        - title: PARTNER_ENUM
          allOf:
            - $ref: '#/components/schemas/CampaignComponentPartnerEnumVariableRequest'
        - title: PARTNER_ENUM_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentPartnerEnumListVariableRequest
        - title: PERSON_KEY_NAME
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableRequestAsPersonKeyName
        - title: REWARD_SUPPLIER_ID
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableRequestAsRewardSupplierId
        - title: REWARD_SUPPLIER_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentRewardSupplierIdListVariableRequest
        - title: SOCKET
          allOf:
            - $ref: '#/components/schemas/CampaignComponentSocketRequestAsSocket'
        - title: STRING
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsString'
        - title: STRING_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableRequestAsStringList
        - title: STRING_MAP
          allOf:
            - $ref: '#/components/schemas/CampaignComponentStringMapVariableRequest'
        - title: URL
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsUrl'
        - title: WEBHOOK_ID
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableRequestAsWebhookId'
      required:
        - name
        - type
    ComponentAssetResponse:
      properties:
        description:
          type: string
        filename:
          type: string
        id:
          type: string
        name:
          type: string
        tags:
          items:
            type: string
          type: array
          uniqueItems: true
      type: object
    ComponentReferenceResponse:
      properties:
        component_id:
          type: string
        socket_names:
          items:
            type: string
          type: array
      type: object
    ZonedDateTime:
      description: >-
        [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339#section-5.6) or
        [RFC 9557](https://datatracker.ietf.org/doc/html/rfc9557#section-4)
        date-time with a numeric [UTC
        offset](https://datatracker.ietf.org/doc/html/rfc3339#section-5.6) and
        an optional [IANA
        time-zone](https://datatracker.ietf.org/doc/html/rfc9557#section-4)
        suffix in square brackets. Precision up to milliseconds.
      example: '2025-10-24T02:00:00-07:00'
      pattern: >-
        ^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\.\d{1,3})?(Z|[+-](?:[01][0-9]|2[0-3]):[0-5][0-9])(\[[^\]]+\])?$
      type: string
    DisplayNameInComponentResponse:
      description: >-
        The display name as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal display name
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{displayName}}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('displayName');}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    CampaignComponentFacetResponse:
      properties:
        name:
          type: string
        value:
          type: string
      type: object
    InstallInComponentResponse:
      description: >-
        The install as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal install
          title: Static Value
          type: object
        - description: >-
            Handlebars expression with
            [ComponentInstalltimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts).
          example: handlebars@installtime:{{install}}
          externalDocs:
            description: ComponentInstalltimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts
          pattern: ^handlebars@installtime:.*
          title: Installtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ComponentInstalltimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts).
          example: >-
            javascript@installtime:function() { return
            context.getVariableContext().get('install');}
          externalDocs:
            description: ComponentInstalltimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts
          pattern: ^javascript@installtime:.*
          title: Installtime - Javascript
          type: string
    ComponentOriginResponse:
      properties:
        client_id:
          type: string
        component_id:
          type: string
        component_version:
          format: int32
          type: integer
      type: object
    CampaignComponentSettingResponse:
      discriminator:
        mapping:
          ADMIN_ICON:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsAdminIcon'
          AUDIENCE_ID:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsAudienceId'
          AUDIENCE_ID_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsAudienceIdList
          BOOLEAN:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsBoolean'
          BROWSER_SIDE_JAVASCRIPT:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsBrowserSideJavascript
          CLIENT_DOMAIN_ID_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsClientDomainIdList
          CLIENT_KEY:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsClientKey'
          CLIENT_KEY_FLOW:
            $ref: >-
              #/components/schemas/CampaignComponentClientKeyFlowVariableResponse
          COLOR:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsColor'
          COMPONENT_ID:
            $ref: '#/components/schemas/CampaignComponentComponentIdVariableResponse'
          COMPONENT_SETTING_LOOKUP:
            $ref: >-
              #/components/schemas/CampaignComponentComponentSettingLookupVariableResponse
          CSS:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsCss'
          DELAY:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsDelay'
          DELAY_LIST:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsDelayList'
          ENUM:
            $ref: '#/components/schemas/CampaignComponentEnumVariableResponse'
          ENUM_LIST:
            $ref: '#/components/schemas/CampaignComponentEnumListVariableResponse'
          EXTOLE_CLIENT_KEY:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsExtoleClientKey
          FONT:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsFont'
          GLOB_COMPONENT_PATH:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsGlobComponentPath
          HTML:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsHtml'
          IMAGE:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsImage'
          INTEGER:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsInteger'
          INTEGER_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsIntegerList
          JSON:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsJson'
          MULTI_SOCKET:
            $ref: '#/components/schemas/CampaignComponentSocketResponseAsMultiSocket'
          PARTNER_ENUM:
            $ref: '#/components/schemas/CampaignComponentPartnerEnumVariableResponse'
          PARTNER_ENUM_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentPartnerEnumListVariableResponse
          PERSON_KEY_NAME:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsPersonKeyName
          REWARD_SUPPLIER_ID:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsRewardSupplierId
          REWARD_SUPPLIER_ID_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentRewardSupplierIdListVariableResponse
          SOCKET:
            $ref: '#/components/schemas/CampaignComponentSocketResponseAsSocket'
          STRING:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsString'
          STRING_LIST:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsStringList'
          STRING_MAP:
            $ref: '#/components/schemas/CampaignComponentStringMapVariableResponse'
          URL:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsUrl'
          WEBHOOK_ID:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsWebhookId'
        propertyName: type
      oneOf:
        - title: ADMIN_ICON
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsAdminIcon
        - title: AUDIENCE_ID
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsAudienceId
        - title: AUDIENCE_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsAudienceIdList
        - title: BOOLEAN
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsBoolean'
        - title: BROWSER_SIDE_JAVASCRIPT
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsBrowserSideJavascript
        - title: CLIENT_DOMAIN_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsClientDomainIdList
        - title: CLIENT_KEY
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsClientKey
        - title: CLIENT_KEY_FLOW
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentClientKeyFlowVariableResponse
        - title: COLOR
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsColor'
        - title: COMPONENT_ID
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentComponentIdVariableResponse
        - title: COMPONENT_SETTING_LOOKUP
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentComponentSettingLookupVariableResponse
        - title: CSS
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsCss'
        - title: DELAY
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsDelay'
        - title: DELAY_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsDelayList
        - title: ENUM
          allOf:
            - $ref: '#/components/schemas/CampaignComponentEnumVariableResponse'
        - title: ENUM_LIST
          allOf:
            - $ref: '#/components/schemas/CampaignComponentEnumListVariableResponse'
        - title: EXTOLE_CLIENT_KEY
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsExtoleClientKey
        - title: FONT
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsFont'
        - title: GLOB_COMPONENT_PATH
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsGlobComponentPath
        - title: HTML
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsHtml'
        - title: IMAGE
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsImage'
        - title: INTEGER
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsInteger'
        - title: INTEGER_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsIntegerList
        - title: JSON
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsJson'
        - title: MULTI_SOCKET
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentSocketResponseAsMultiSocket
        - title: PARTNER_ENUM
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentPartnerEnumVariableResponse
        - title: PARTNER_ENUM_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentPartnerEnumListVariableResponse
        - title: PERSON_KEY_NAME
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsPersonKeyName
        - title: REWARD_SUPPLIER_ID
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsRewardSupplierId
        - title: REWARD_SUPPLIER_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentRewardSupplierIdListVariableResponse
        - title: SOCKET
          allOf:
            - $ref: '#/components/schemas/CampaignComponentSocketResponseAsSocket'
        - title: STRING
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsString'
        - title: STRING_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsStringList
        - title: STRING_MAP
          allOf:
            - $ref: '#/components/schemas/CampaignComponentStringMapVariableResponse'
        - title: URL
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsUrl'
        - title: WEBHOOK_ID
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsWebhookId
      required:
        - description
        - display_name
        - name
        - priority
        - tags
        - type
    CampaignComponentVariableRequestAsAdminIcon:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsAdminIcon
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - ADMIN_ICON
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsAdminIcon'
          type: object
      type: object
      title: ADMIN_ICON
    CampaignComponentVariableRequestAsAudienceId:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsAudienceId
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - AUDIENCE_ID
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsAudienceId'
          type: object
      type: object
      title: AUDIENCE_ID
    CampaignComponentVariableRequestAsAudienceIdList:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsAudienceIdList
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - AUDIENCE_ID_LIST
              type: string
            values:
              $ref: >-
                #/components/schemas/ComponentSettingVariableValuesAsAudienceIdList
          type: object
      type: object
      title: AUDIENCE_ID_LIST
    CampaignComponentVariableRequestAsBoolean:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsBoolean
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - BOOLEAN
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsBoolean'
          type: object
      type: object
      title: BOOLEAN
    CampaignComponentVariableRequestAsBrowserSideJavascript:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsBrowserSideJavascript
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - BROWSER_SIDE_JAVASCRIPT
              type: string
            values:
              $ref: >-
                #/components/schemas/ComponentSettingVariableValuesAsBrowserSideJavascript
          type: object
      type: object
      title: BROWSER_SIDE_JAVASCRIPT
    CampaignComponentVariableRequestAsClientDomainIdList:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsClientDomainIdList
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - CLIENT_DOMAIN_ID_LIST
              type: string
            values:
              $ref: >-
                #/components/schemas/ComponentSettingVariableValuesAsClientDomainIdList
          type: object
      type: object
      title: CLIENT_DOMAIN_ID_LIST
    CampaignComponentVariableRequestAsClientKey:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsClientKey
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - CLIENT_KEY
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsClientKey'
          type: object
      type: object
      title: CLIENT_KEY
    CampaignComponentClientKeyFlowVariableRequest:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            authorization_url:
              type: string
            client_secret_key_id:
              type: string
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentClientKeyFlowVariableRequest
            redirect_url:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - CLIENT_KEY_FLOW
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValues'
          type: object
      required:
        - name
        - type
      type: object
      title: CLIENT_KEY_FLOW
    CampaignComponentVariableRequestAsColor:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsColor
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - COLOR
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsColor'
          type: object
      type: object
      title: COLOR
    CampaignComponentComponentIdVariableRequest:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentComponentIdVariableRequest
            filter:
              $ref: '#/components/schemas/ComponentIdFilterCreateRequest'
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - COMPONENT_ID
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValues'
          type: object
      required:
        - name
        - type
      type: object
      title: COMPONENT_ID
    CampaignComponentComponentSettingLookupVariableRequest:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            capture_settings:
              items:
                type: string
              type: array
            captured_setting_values_description:
              $ref: >-
                #/components/schemas/CapturedSettingValuesDescriptionInCampaignComponentComponentSettingLookupVariableRequest
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentComponentSettingLookupVariableRequest
            filters:
              items:
                $ref: '#/components/schemas/SettingFilterCreateRequest'
              type: array
            matching_filters:
              items:
                $ref: '#/components/schemas/SettingFilterCreateRequest'
              type: array
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - COMPONENT_SETTING_LOOKUP
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValues'
          type: object
      required:
        - captured_setting_values_description
        - name
        - type
      type: object
      title: COMPONENT_SETTING_LOOKUP
    CampaignComponentVariableRequestAsCss:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsCss
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - CSS
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsCss'
          type: object
      type: object
      title: CSS
    CampaignComponentVariableRequestAsDelay:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsDelay
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - DELAY
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsDelay'
          type: object
      type: object
      title: DELAY
    CampaignComponentVariableRequestAsDelayList:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsDelayList
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - DELAY_LIST
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsDelayList'
          type: object
      type: object
      title: DELAY_LIST
    CampaignComponentEnumVariableRequest:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            allowed_values:
              items:
                type: string
              type: array
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentEnumVariableRequest
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - ENUM
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValues'
          type: object
      required:
        - name
        - type
      type: object
      title: ENUM
    CampaignComponentEnumListVariableRequest:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            allowed_values:
              items:
                type: string
              type: array
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentEnumListVariableRequest
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - ENUM_LIST
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValues'
          type: object
      required:
        - name
        - type
      type: object
      title: ENUM_LIST
    CampaignComponentVariableRequestAsExtoleClientKey:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsExtoleClientKey
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - EXTOLE_CLIENT_KEY
              type: string
            values:
              $ref: >-
                #/components/schemas/ComponentSettingVariableValuesAsExtoleClientKey
          type: object
      type: object
      title: EXTOLE_CLIENT_KEY
    CampaignComponentVariableRequestAsFont:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsFont
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - FONT
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsFont'
          type: object
      type: object
      title: FONT
    CampaignComponentVariableRequestAsGlobComponentPath:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsGlobComponentPath
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - GLOB_COMPONENT_PATH
              type: string
            values:
              $ref: >-
                #/components/schemas/ComponentSettingVariableValuesAsGlobComponentPath
          type: object
      type: object
      title: GLOB_COMPONENT_PATH
    CampaignComponentVariableRequestAsHtml:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsHtml
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - HTML
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsHtml'
          type: object
      type: object
      title: HTML
    CampaignComponentVariableRequestAsImage:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsImage
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - IMAGE
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsImage'
          type: object
      type: object
      title: IMAGE
    CampaignComponentVariableRequestAsInteger:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsInteger
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - INTEGER
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsInteger'
          type: object
      type: object
      title: INTEGER
    CampaignComponentVariableRequestAsIntegerList:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsIntegerList
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - INTEGER_LIST
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsIntegerList'
          type: object
      type: object
      title: INTEGER_LIST
    CampaignComponentVariableRequestAsJson:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsJson
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - JSON
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsJson'
          type: object
      type: object
      title: JSON
    CampaignComponentSocketRequestAsMultiSocket:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentSocketRequestAsMultiSocket
            filters:
              items:
                $ref: '#/components/schemas/SettingFilterCreateRequest'
              type: array
            parameters:
              items:
                $ref: '#/components/schemas/CampaignComponentVariableRequest'
              type: array
            socketed_component_ids:
              items:
                type: string
              type: array
            type:
              enum:
                - MULTI_SOCKET
              type: string
          type: object
      required:
        - name
        - type
      type: object
      title: MULTI_SOCKET
    CampaignComponentPartnerEnumVariableRequest:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentPartnerEnumVariableRequest
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - PARTNER_ENUM
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValues'
            webhook_id:
              $ref: >-
                #/components/schemas/WebhookIdInCampaignComponentPartnerEnumVariableRequest
            options:
              items:
                $ref: >-
                  #/components/schemas/PartnerEnumListVariableOptionCreateRequest
              type: array
          type: object
      required:
        - name
        - type
      type: object
      title: PARTNER_ENUM
    CampaignComponentPartnerEnumListVariableRequest:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentPartnerEnumListVariableRequest
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - PARTNER_ENUM_LIST
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValues'
            webhook_id:
              $ref: >-
                #/components/schemas/WebhookIdInCampaignComponentPartnerEnumListVariableRequest
            options:
              items:
                $ref: >-
                  #/components/schemas/PartnerEnumListVariableOptionCreateRequest
              type: array
          type: object
      required:
        - name
        - type
      type: object
      title: PARTNER_ENUM_LIST
    CampaignComponentVariableRequestAsPersonKeyName:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsPersonKeyName
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - PERSON_KEY_NAME
              type: string
            values:
              $ref: >-
                #/components/schemas/ComponentSettingVariableValuesAsPersonKeyName
          type: object
      type: object
      title: PERSON_KEY_NAME
    CampaignComponentVariableRequestAsRewardSupplierId:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsRewardSupplierId
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - REWARD_SUPPLIER_ID
              type: string
            values:
              $ref: >-
                #/components/schemas/ComponentSettingVariableValuesAsRewardSupplierId
          type: object
      type: object
      title: REWARD_SUPPLIER_ID
    CampaignComponentRewardSupplierIdListVariableRequest:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            allowed_reward_supplier_ids:
              $ref: >-
                #/components/schemas/AllowedRewardSupplierIdsInCampaignComponentRewardSupplierIdListVariableRequest
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentRewardSupplierIdListVariableRequest
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - REWARD_SUPPLIER_ID_LIST
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValues'
          type: object
      required:
        - name
        - type
      type: object
      title: REWARD_SUPPLIER_ID_LIST
    CampaignComponentSocketRequestAsSocket:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentSocketRequestAsSocket
            filters:
              items:
                $ref: '#/components/schemas/SettingFilterCreateRequest'
              type: array
            parameters:
              items:
                $ref: '#/components/schemas/CampaignComponentVariableRequest'
              type: array
            socketed_component_ids:
              items:
                type: string
              type: array
            type:
              enum:
                - SOCKET
              type: string
          type: object
      required:
        - name
        - type
      type: object
      title: SOCKET
    CampaignComponentVariableRequestAsString:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsString
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - STRING
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsString'
          type: object
      type: object
      title: STRING
    CampaignComponentVariableRequestAsStringList:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsStringList
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - STRING_LIST
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsStringList'
          type: object
      type: object
      title: STRING_LIST
    CampaignComponentStringMapVariableRequest:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            allowed_keys:
              items:
                type: string
              type: array
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentStringMapVariableRequest
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - STRING_MAP
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValues'
          type: object
      required:
        - name
        - type
      type: object
      title: STRING_MAP
    CampaignComponentVariableRequestAsUrl:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsUrl
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - URL
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsUrl'
          type: object
      type: object
      title: URL
    CampaignComponentVariableRequestAsWebhookId:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingRequestBase'
        - properties:
            description:
              $ref: >-
                #/components/schemas/DescriptionInCampaignComponentVariableRequestAsWebhookId
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - WEBHOOK_ID
              type: string
            values:
              $ref: '#/components/schemas/ComponentSettingVariableValuesAsWebhookId'
          type: object
      type: object
      title: WEBHOOK_ID
    CampaignComponentVariableResponseAsAdminIcon:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingResponseBase'
        - properties:
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - ADMIN_ICON
              type: string
            values:
              additionalProperties: true
              description: >-
                Open map of setting values keyed by value key. There is no fixed
                or maximum number of keys. Any string key may be present; each
                value uses the same shape for this setting's `type`. The
                properties listed here are common examples only and are not
                required.
              properties:
                default:
                  $ref: >-
                    #/components/schemas/DefaultInComponentSettingVariableValuesOpenApiDocumentation
                en:
                  $ref: >-
                    #/components/schemas/EnInComponentSettingVariableValuesOpenApiDocumentation
              type: object
          type: object
      type: object
      title: ADMIN_ICON
    CampaignComponentVariableResponseAsAudienceId:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingResponseBase'
        - properties:
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - AUDIENCE_ID
              type: string
            values:
              additionalProperties: true
              description: >-
                Open map of setting values keyed by value key. There is no fixed
                or maximum number of keys. Any string key may be present; each
                value uses the same shape for this setting's `type`. The
                properties listed here are common examples only and are not
                required.
              properties:
                default:
                  $ref: >-
                    #/components/schemas/DefaultInComponentSettingVariableValuesOpenApiDocumentation
                en:
                  $ref: >-
                    #/components/schemas/EnInComponentSettingVariableValuesOpenApiDocumentation
              type: object
          type: object
      type: object
      title: AUDIENCE_ID
    CampaignComponentVariableResponseAsAudienceIdList:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingResponseBase'
        - properties:
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - AUDIENCE_ID_LIST
              type: string
            values:
              additionalProperties: true
              description: >-
                Open map of setting values keyed by value key. There is no fixed
                or maximum number of keys. Any string key may be present; each
                value uses the same shape for this setting's `type`. The
                properties listed here are common examples only and are not
                required.
              properties:
                default:
                  $ref: >-
                    #/components/schemas/DefaultInComponentSettingVariableValuesOpenApiDocumentation
                en:
                  $ref: >-
                    #/components/schemas/EnInComponentSettingVariableValuesOpenApiDocumentation
              type: object
          type: object
      type: object
      title: AUDIENCE_ID_LIST
    CampaignComponentVariableResponseAsBoolean:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingResponseBase'
        - properties:
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - BOOLEAN
              type: string
            values:
              additionalProperties: true
              description: >-
                Open map of setting values keyed by value key. There is no fixed
                or maximum number of keys. Any string key may be present; each
                value uses the same shape for this setting's `type`. The
                properties listed here are common examples only and are not
                required.
              properties:
                default:
                  $ref: >-
                    #/components/schemas/DefaultInComponentSettingVariableValuesOpenApiDocumentation
                en:
                  $ref: >-
                    #/components/schemas/EnInComponentSettingVariableValuesOpenApiDocumentation
              type: object
          type: object
      type: object
      title: BOOLEAN
    CampaignComponentVariableResponseAsBrowserSideJavascript:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingResponseBase'
        - properties:
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - BROWSER_SIDE_JAVASCRIPT
              type: string
            values:
              additionalProperties: true
              description: >-
                Open map of setting values keyed by value key. There is no fixed
                or maximum number of keys. Any string key may be present; each
                value uses the same shape for this setting's `type`. The
                properties listed here are common examples only and are not
                required.
              properties:
                default:
                  $ref: >-
                    #/components/schemas/DefaultInComponentSettingVariableValuesOpenApiDocumentation
                en:
                  $ref: >-
                    #/components/schemas/EnInComponentSettingVariableValuesOpenApiDocumentation
              type: object
          type: object
      type: object
      title: BROWSER_SIDE_JAVASCRIPT
    CampaignComponentVariableResponseAsClientDomainIdList:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingResponseBase'
        - properties:
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - CLIENT_DOMAIN_ID_LIST
              type: string
            values:
              additionalProperties: true
              description: >-
                Open map of setting values keyed by value key. There is no fixed
                or maximum number of keys. Any string key may be present; each
                value uses the same shape for this setting's `type`. The
                properties listed here are common examples only and are not
                required.
              properties:
                default:
                  $ref: >-
                    #/components/schemas/DefaultInComponentSettingVariableValuesOpenApiDocumentation
                en:
                  $ref: >-
                    #/components/schemas/EnInComponentSettingVariableValuesOpenApiDocumentation
              type: object
          type: object
      type: object
      title: CLIENT_DOMAIN_ID_LIST
    CampaignComponentVariableResponseAsClientKey:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingResponseBase'
        - properties:
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - CLIENT_KEY
              type: string
            values:
              additionalProperties: true
              description: >-
                Open map of setting values keyed by value key. There is no fixed
                or maximum number of keys. Any string key may be present; each
                value uses the same shape for this setting's `type`. The
                properties listed here are common examples only and are not
                required.
              properties:
                default:
                  $ref: >-
                    #/components/schemas/DefaultInComponentSettingVariableValuesOpenApiDocumentation
                en:
                  $ref: >-
                    #/components/schemas/EnInComponentSettingVariableValuesOpenApiDocumentation
              type: object
          type: object
      type: object
      title: CLIENT_KEY
    CampaignComponentClientKeyFlowVariableResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingResponseBase'
        - properties:
            authorization_url:
              type: string
            client_secret_key_id:
              type: string
            redirect_url:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - CLIENT_KEY_FLOW
              type: string
            values:
              additionalProperties: true
              description: >-
                Open map of setting values keyed by value key. There is no fixed
                or maximum number of keys. Any string key may be present; each
                value uses the same shape for this setting's `type`. The
                properties listed here are common examples only and are not
                required.
              properties:
                default:
                  $ref: >-
                    #/components/schemas/DefaultInComponentSettingVariableValuesOpenApiDocumentation
                en:
                  $ref: >-
                    #/components/schemas/EnInComponentSettingVariableValuesOpenApiDocumentation
              type: object
          type: object
      description: >-
        Stored campaign component client key flow variable definition. Field
        `description` is unevaluated and appears in buildtime-evaluatable form.
      required:
        - authorization_url
        - client_secret_key_id
        - description
        - display_name
        - name
        - priority
        - redirect_url
        - source
        - tags
        - type
        - values
      type: object
      title: CLIENT_KEY_FLOW
    CampaignComponentVariableResponseAsColor:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingResponseBase'
        - properties:
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
                - COLOR
              type: string
            values:
              additionalProperties: true
              description: >-
                Open map of setting values keyed by value key. There is no fixed
                or maximum number of keys. Any string key may be present; each
                value uses the same shape for this setting's `type`. The
                properties listed here are common examples only and are not
                required.
              properties:
                default:
                  $ref: >-
                    #/components/schemas/DefaultInComponentSettingVariableValuesOpenApiDocumentation
                en:
                  $ref: >-
                    #/components/schemas/EnInComponentSettingVariableValuesOpenApiDocumentation
              type: object
          type: object
      type: object
      title: COLOR
    CampaignComponentComponentIdVariableResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignComponentSettingResponseBase'
        - properties:
            filter:
              $ref: '#/components/schemas/ComponentIdFilterResponse'
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            type:
              enum:
[...]
